apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "ndcs-server.fullname" . }}
  labels:
    {{- include "ndcs-server.labels" . | nindent 4 }}
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "ndcs-server.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "ndcs-server.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "ndcs-server.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          env:
          - name: "NDCSSERVERURL"
            valueFrom:
              configMapKeyRef:
                key: "NDCSSERVERURL"
                name: "{{ include "ndcs-server.fullname" . }}-config"
          - name: "JAVA_OPTS"
            valueFrom:
              configMapKeyRef:
                key: "JAVA_OPTS"
                name: "{{ include "ndcs-server.fullname" . }}-config"
          - name: "DATABASE_HOST"
            valueFrom:
              configMapKeyRef:
                key: "DATABASE_HOST"
                name: "{{ include "ndcs-server.fullname" . }}-config"
          - name: "DATABASE_PORT"
            valueFrom:
              configMapKeyRef:
                key: "DATABASE_PORT"
                name: "{{ include "ndcs-server.fullname" . }}-config"
          - name: "MAIL_SMTP_HOST"
            valueFrom:
              configMapKeyRef:
                key: "MAIL_SMTP_HOST"
                name: "{{ include "ndcs-server.fullname" . }}-config"
          ports:
            - name: http
              containerPort: 8787
              protocol: TCP
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
